﻿    //---------------------------------------------------
// Project: RemaBands
// Language: MQL4
// Type: Indicator
// Author: JWG
// Company: 
// Copyright: 
// Created: 2014/01/02
//---------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 3

double upperRemaBuffer[];
double regEMABuffer[];
double lowerRemaBuffer[];
double testBuffer[];
int draw_begin =3;

extern int EMA_Length 	= 22;
double PctBelow			= 0.5;
double PctAbove			= 0.5;
double Alpha=0.0, PctBelowFactor=0.0, PctAboveFactor=0.0;
double Lambda=0.5;

int init()
{
   SetIndexBuffer(0, upperRemaBuffer);
   SetIndexStyle(0, DRAW_LINE, EMPTY, 1, Blue);

   SetIndexBuffer(1, regEMABuffer);
   SetIndexStyle(1, DRAW_LINE, EMPTY, 1, White);
   
   SetIndexBuffer(2, lowerRemaBuffer);
   SetIndexStyle(2, DRAW_LINE, EMPTY, 1, Red);
  return(0);
  
}

int deinit()
{
  return(0);
}

int start()
{

int counted_bars=IndicatorCounted();
int limit;
if	(counted_bars < 0) return(-1);
if	(counted_bars > 0) counted_bars--;
limit = Bars-counted_bars;

Alpha = 2/(EMA_Length + 1);
PctBelowFactor	= (1 - (0.5*0.01)); 
PctAboveFactor	= (1 + (0.5*0.01));

int limit2 = Bars - IndicatorCounted();
   
  	
   
   for (int i = limit2;  i>= 0; i--) 
   	{
	if(limit2 < 3)
	{
	regEMABuffer[i]  = Close[i];
	}
	else
	{
	regEMABuffer[i]  = (regEMABuffer[i+1]*(1+2*Lambda) + Alpha * (Close[i]-regEMABuffer[i+1])- Lambda * regEMABuffer[i+2])/(1+Lambda);
	}
	
	//lowerRemaBuffer[i] = regEMABuffer[i] * PctBelowFactor;
	//upperRemaBuffer[i] = regEMABuffer[i] * PctAboveFactor;
	}
return(0);
}